package com.njcn.energy.controller;

import com.njcn.common.pojo.annotation.OperateInfo;
import com.njcn.common.pojo.enums.common.LogEnum;
import com.njcn.common.pojo.enums.response.CommonResponseEnum;
import com.njcn.common.pojo.response.HttpResult;
import com.njcn.common.utils.HttpResultUtil;
import com.njcn.common.utils.LogUtil;
import com.njcn.energy.pojo.po.EleDi;
import com.njcn.energy.pojo.po.EleEpdPqd;
import com.njcn.energy.service.IEleDiService;
import com.njcn.energy.service.IEleEpdPqdService;
import com.njcn.web.controller.BaseController;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiOperation;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.*;

/**
 * 类的介绍：
 *
 * @author xuyang
 * @version 1.0.0
 * @createTime 2022/3/15 19:17
 */
@Slf4j
@RestController
@RequestMapping("/di")
@RequiredArgsConstructor
@Api(tags = "开入信号量数据管理")
public class EleDiController extends BaseController {

    private final IEleDiService eleDiService;

    @PostMapping("/add")
    @OperateInfo(info = LogEnum.SYSTEM_COMMON)
    @ApiOperation("新增开入信号量数据")
    @ApiImplicitParam(name = "eleDi", value = "开入信号量数据", required = true)
    public HttpResult<Boolean> add(@RequestBody EleDi eleDi){
        String methodDescribe = getMethodDescribe("add");
        LogUtil.njcnDebug(log, "{}，开入信号量数据：{}", methodDescribe, eleDi);
        boolean result = eleDiService.addDi(eleDi);
        return HttpResultUtil.assembleCommonResponseResult(CommonResponseEnum.SUCCESS, result, methodDescribe);
    }

    @PutMapping("/update")
    @OperateInfo(info = LogEnum.SYSTEM_COMMON)
    @ApiOperation("修改开入信号量数据")
    @ApiImplicitParam(name = "eleDi", value = "开入信号量数据", required = true)
    public HttpResult<Boolean> update(@RequestBody EleDi eleDi){
        String methodDescribe = getMethodDescribe("update");
        LogUtil.njcnDebug(log, "{}，开入信号量数据：{}", methodDescribe, eleDi);
        boolean result = eleDiService.updateDi(eleDi);
        return HttpResultUtil.assembleCommonResponseResult(CommonResponseEnum.SUCCESS, result, methodDescribe);
    }

    @GetMapping("/findByName")
    @OperateInfo(info = LogEnum.SYSTEM_COMMON)
    @ApiOperation("根据名称查找数据")
    @ApiImplicitParam(name = "name", value = "名称", required = true)
    public HttpResult<EleDi> findByName(@RequestParam String name){
        String methodDescribe = getMethodDescribe("findByName");
        LogUtil.njcnDebug(log, "{}，名称为：{}", methodDescribe, name);
        EleDi eleDi = eleDiService.findByName(name);
        return HttpResultUtil.assembleCommonResponseResult(CommonResponseEnum.SUCCESS, eleDi, methodDescribe);
    }



}
